Attribute VB_Name = "modSampleOfUtf8ToUcs2Conv"
Private Declare Sub MessageBox Lib "user32" Alias "MessageBoxW" (ByVal hwnd As Long, sText As Any, sCaption As Any, ByVal Style As VbMsgBoxStyle)
Private Declare Function MultiByteToWideChar Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, lpMultiByteStr As Any, ByVal cchMultiByte As Long, lpWideCharStr As Any, ByVal cchWideChar As Long) As Long
Private Const CP_UTF8 = 65001

Public Sub Main()
    ' Hello, , , , , 
    Dim i As Long
    Dim vBytes()
    '               {H}   {e}   {l}   {l}   {o}   {,}   { }    {    }     {  c  }     {    }     {    }     {    }     {    }     {    }    {     }     {    }    {,}   { }   {            -          }  {,}   {  }  {S}   {t}   {r}   {a}     {SS}      {e}   {,}   { }  {                           }   {,}   { }   %D0   %B4   %D3   %99   %D1   %80   %D1   %96   %D1  %85    %D0   %B0   %D0   %BD   %D0   %B0 {!}
    vBytes = Array(&H48, &H65, &H6C, &H6C, &H6F, &H2C, &H20, &HD0, &H92, &HD1, &H81, &HD0, &HB5, &HD0, &HBB, &HD0, &HB5, &HD0, &HBD, &HD0, &HBD, &HD0, &HB0, &HD1, &H8F, &H2C, &H20, &HD9, &H86, &HD9, &H87, &HD8, &HA7, &HD8, &HB1, &H2C, &H20, &H53, &H74, &H72, &H61, &HC3, &H9F, &H65, &H2C, &H20, &HCF, &H86, &HCE, &HB1, &HCE, &HBD, &HCF, &H8C, &HCF, &H82, &H2C, &H20, &HD0, &HB4, &HD3, &H99, &HD1, &H80, &HD1, &H96, &HD1, &H85, &HD0, &HB0, &HD0, &HBD, &HD0, &HB0, &H21, &H21)
    
    Dim ba_Utf8_As_Byte_Array(0 To 75)  As Byte
    Dim s_Utf8_As_String_As_Is          As String
    Dim s_Utf8_As_String_Stupid         As String
    Dim sResult As String
    
    For i = LBound(vBytes) To UBound(vBytes)
        ba_Utf8_As_Byte_Array(i) = vBytes(i)
        
        s_Utf8_As_String_Stupid = s_Utf8_As_String_Stupid + Chr(vBytes(i))
    Next i
    
    s_Utf8_As_String_As_Is = ba_Utf8_As_Byte_Array
    
    '
    ' .
    ' ba_Utf8_As_Byte_Array    UTF8-.
    ' s_Utf8_As_String_As_Is    UTF8-.
    ' s_Utf8_As_String_Stupid  ,      UTF8-
    '
    ' ...
    '
    
    sResult = "        Utf8ToUcs2:" + vbNewLine + _
              "     : " + Utf8ToUcs2(ba_Utf8_As_Byte_Array) + "" + vbNewLine + vbNewLine + _
              "  UTF8,     :" + vbNewLine + _
              "     : " + s_Utf8_As_String_As_Is + "" + vbNewLine + _
              "     : " + Utf8AsIsToUcs2(s_Utf8_As_String_As_Is) + "" + vbNewLine + vbNewLine + _
              "  UTF8, -   :" + vbNewLine + _
              "     : " + s_Utf8_As_String_Stupid + "" + vbNewLine + _
              "     : " + Utf8DirtyToUcs2(s_Utf8_As_String_Stupid) + "."
    
    MessageBox 0, ByVal StrPtr(sResult), ByVal StrPtr(""), vbInformation
End Sub















Public Function Utf8ToUcs2(ByRef sInputUtf8Str() As Byte) As String
    Dim ret As Long
    Dim nInpLength As Long: nInpLength = ByteArySize(sInputUtf8Str)
    If nInpLength = 0 Then Exit Function Else Utf8ToUcs2 = Space(nInpLength)
    ret = MultiByteToWideChar(CP_UTF8, 0, _
                              sInputUtf8Str(LBound(sInputUtf8Str)), nInpLength, _
                              ByVal StrPtr(Utf8ToUcs2), nInpLength)
    If ret = 0 Then Error 51 Else Utf8ToUcs2 = Left$(Utf8ToUcs2, ret)
End Function

Public Function Utf8AsIsToUcs2(ByRef sAsIsBytes As String) As String
    Dim ret As Long
    Dim nInpLength As Long: nInpLength = LenB(sAsIsBytes)
    If nInpLength = 0 Then Exit Function Else Utf8AsIsToUcs2 = Space(nInpLength)
    ret = MultiByteToWideChar(CP_UTF8, 0, _
                              ByVal StrPtr(sAsIsBytes), nInpLength, _
                              ByVal StrPtr(Utf8AsIsToUcs2), nInpLength)
    If ret = 0 Then Error 51 Else Utf8AsIsToUcs2 = Left$(Utf8AsIsToUcs2, ret)
End Function

Public Function Utf8DirtyToUcs2(ByVal sDirtyString As String) As String
    Dim ret As Long
    Dim nInpLength As Long: nInpLength = Len(sDirtyString)
    If nInpLength = 0 Then Exit Function Else Utf8DirtyToUcs2 = Space(nInpLength)
    sDirtyString = StrConv(sDirtyString, vbFromUnicode)
    ret = MultiByteToWideChar(CP_UTF8, 0, _
                              ByVal StrPtr(sDirtyString), nInpLength, _
                              ByVal StrPtr(Utf8DirtyToUcs2), nInpLength)
    If ret = 0 Then Error 51 Else Utf8DirtyToUcs2 = Left$(Utf8DirtyToUcs2, ret)
End Function



















Private Function ByteArySize(ByRef b() As Byte) As Long
    On Error Resume Next
    ByteArySize = UBound(b) - LBound(b) + 1
End Function

